
/************** Création des Triggers **************/
/* Les triggers remplaçant les FK */
SET TERM ^ ;

CREATE TRIGGER TR_STLI_STRU_ENFANT_INSERT FOR STRUCTURE_LIEE 
BEFORE INSERT OR UPDATE
AS
   DECLARE CLEP INTEGER;
   DECLARE CONTINUER boolean;
BEGIN
CONTINUER=true;
for SELECT 1 FROM STRUCTURE WHERE STRU_Clep = new.STLI__Enfant INTO :CLEP DO
    BEGIN
      IF (CLEP is not null) then
        /* raise error */
        CONTINUER = FALSE;
      suspend;
    END
IF (CONTINUER) THEN
  new.STLI__Enfant = Null;
END^

CREATE TRIGGER TR_STRU_STLI_ENFANT_UPDATE FOR STRUCTURE 
BEFORE UPDATE
AS
BEGIN
IF ((old.STRU_Clep)<>(new.STRU_Clep)) then
	BEGIN
		ALTER TRIGGER  TR_STLI_STRU_ENFANT_INSERT INACTIVE;
		UPDATE STRUCTURE_LIEE SET STLI__Enfant = new.STRU_Clep WHERE STLI__Enfant = old.STRU_Clep;
		ALTER TRIGGER  TR_STLI_STRU_ENFANT_INSERT ACTIVE;
	END
END^

CREATE TRIGGER TR_STRU_STLI_ENFANT_DELETE FOR STRUCTURE 
BEFORE DELETE
AS
   DECLARE VARIABLE CLEP INTEGER;
BEGIN
    FOR SELECT 1 FROM STRUCTURE_LIEE WHERE  STLI__Enfant = old.STRU_Clep INTO .CLEP DO
IF (CLEP IS NULL) THEN
	DELETE FROM STRUCTURE_LIEE WHERE STLI__Enfant = old.STRU_Clep;
END^

SET TERM ; ^
